#
# spec file for package ghc-RefSerialize
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name RefSerialize
Name:           ghc-%{pkg_name}
Version:        0.4.0
Release:        1.11
Summary:        Write to and read from ByteStrings maintaining internal memory references
License:        BSD-3-Clause
Group:          Development/Languages/Other
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-binary-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-hashtables-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-stringsearch-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Read, Show and Binary instances do not check for internal data references to
the same address. As a result, the data is duplicated when serialized.
This is a waste of space in the filesystem and also a waste of serialization
time. but the worst consequence is that, when the serialized data is read, it
allocates multiple copies for the same object when referenced multiple times.
Because multiple referenced data is very typical in a pure language such is
Haskell, this means that the resulting data loose the beatiful economy of space
and processing time that referential transparency permits.

In this release:

Compatibility with older versions of bytestring that have no 'toStrict' call

deserialization is much, much faster by using the stringsearch package

See "Data.RefSerialize" for details.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%defattr(-,root,root,-)
%doc LICENSE

%files devel -f %{name}-devel.files
%defattr(-,root,root,-)

%changelog
* Sun Feb 12 2017 psimons@suse.com
- Update to version 0.4.0 with cabal2obs.
* Sun Jul 10 2016 psimons@suse.com
- Update to version 0.3.1.4 revision 0 with cabal2obs.
